	Program test_f2c
	
c	This is a FORTRAN program to test Mac F2C v1.4

	character	junk*2
	character	today*9
	character	now*8
	
	write(6,*) '\n*****   Mac F2C Test Program  *****\n'
	call date( today )
	call time( now )
	write(6,10) today, now
10	format( 'Date:  ', a9, 3x, 'Time:  ', a8 )
	
	write(6,*) '\n\n*****   Input/Output Test   *****'
	call i_o_test
	write(6,*) '\n*****   End of I/O test, hit return to continue...'
	read(5,99) junk
99	format( a1 )

	write(6,*) '\n*****   Integer Math Test   *****'	
	call int_test( 10 )
	write(6,*) '\n*****   End of integer math test, hit return to continue...'
	read(5,99) junk

	write(6,*) '\n*****   Floating Point Math Test   *****'
	call flt_test( 10 )
	write(6,*) '\n*****   End of floating point math test, hit return to continue...'
	read(5,99) junk

	write(6,*) '\n*****   Algebraic Function Test   *****'
	call alg_test( 10 )
	write(6,*) '\n*****   End of algebraic function test, hit return to continue...'
	read(5,99) junk

	write(6,*) '\n*****   Transcendental Function Test   *****'
	call trn_test
	write(6,*) '\n*****   End of transcendental function test, hit return to continue...'
	read(5,99) junk
	
	write(6,*) '\n*****   Complex Math Test   *****'
	call cm_test
	write(6,*) '\n*****   End of complex math test, hit return to continue...'
	read(5,99) junk
	
	write(6,*) '\n*****   Complex Algebra Test   *****'
	call ca_test
	write(6,*) '\n*****   End of complex algebra test, hit return to continue...'
	read(5,99) junk
	
	write(6,*) '\n*****   Complex Function Test   *****'
	call cf_test
	write(6,*) '\n*****   End of complex function test, hit return to continue...'
	read(5,99) junk
	
	write(6,*) '\n*****   Quad Integer (INTEGER*8) Test   *****'
	call q_test
	write(6,*) '\n*****   End of quad integer test, hit return to continue...'
	read(5,99) junk
	
	write(6,*) '\n*****   This completes all of the tests   *****'
	
	stop
	end
	
	

c************************************************************************
c
c	Subroutine to do the I/O tests
c
c************************************************************************
	
	subroutine  i_o_test
	dimension a(5), j(5)
	double precision  dx
	character text*40
	
c 	Screen I/O tests

	write(6,*) '\nPart 1:  Screen I/O tests.\n\nEnter an integer value.'
	read(5,*) i
	write(6,*) 'The number you entered was:', i

	write(6,*) '\nEnter a single precision floating point value...'
	read(5,*) x
	write(6,312) x
312	format(1x, 'The number you entered was: ', f13.6)

	write(6,*) '\nEnter a double precision floating point value...'
	read(5,*) dx
	write(6,313) dx
313	format(1x, 'The number you entered was: ', f17.10)

	write(6,*) '\nEnter some text (40 char max)...'
	read(5,*) text
	write(6,*) 'The text you entered was: ', text
	
	write(6,*) '\nPart 2:  file I/O tests.  Hit return to continue...'
	read(5,399) text
399	format( a1 )
	
c 	File I/O tests:  Store some values and write them to file

	do i = 1,5
	  j(i) = i
	  a(i) = dble(i)
	enddo
	text = 'A test message.'
	open(60,file='test.dat',form='unformatted')
	write(60) text, j, a
	close(60)
	
	write(6,*) 'Wrote the following data to file test.dat:\n'
	write(6, 304) text, (j(i), i =1,5), (a(i), i = 1,5)
304	format( 5x, a20, 5(i1, 2x), 5x, 5(f4.2, 2x) )

c Reset the variables and read them back

	do i = 1,5
	  j(i) = 99
	  a(i) = 99
	enddo
	text = 'reset'
	open(50,file='test.dat',form='unformatted')
	read(50) text, j, a
	close(50)
	
	write(6, *) '\nRead the following data from file test.dat:\n' 
	write(6, 304) text, (j(i), i =1,5), (a(i), i = 1,5)

	return
	end
	
	
	
	
c************************************************************************
c
c	Subroutine to do the integer math tests
c
c************************************************************************

	subroutine  int_test( m )
	write( 6, *) '\nGenerate a table of integers, squares, cubes, and their halves.\n'
	write(6, 203)
203	format( 10x, 'n', 5x, 'n^2', 5x, 'n^3', 5x, 'n/2', 3x, 'n^2/2', 3x, 'n^3/2' )
	do i = 1, m
		j = i**2
		k = i**3
		write( 6, 202 )  i, j, k, i/2, j/2, k/2
202		format( 5x, 6( i6, 2x ) )
	end do
	return
	end



c************************************************************************
c
c	Subroutine to do the floating point math tests
c
c************************************************************************

	subroutine  flt_test( m )
	write( 6, * ) '\nGenerate a table of floats, their squares, cubes, and their halves.\n'
	write(6, 205)
205	format( 12x, 'x', 6x, 'x^2', 6x, 'x^3', 6x, 'x/2', 4x, 'x^2/2', 4x, 'x^3/2' )
	do i = 1, m
		x1 = i*1.0
		x2 = x1**2
		x3 = x1**3
		write( 6, 201 )  x1, x2, x3, x1/2, x2/2, x3/2
201		format( 5x, 6( f8.2, 1x ) )
	end do
	return
	end




c************************************************************************
c
c	Subroutine to do the algebraic function tests
c
c************************************************************************

	subroutine  alg_test( m )
	write( 6, * ) '\nGenerate a table of floats, square & cube roots, and their squares & cubes.\n'
	write(6, 305)
305	format( 10x, 'x', 7x, 'SQRT(x)', 4x, 'CURT(x)', 3x, 'SQRT(x)^2', 2x, 'CURT(x)^3' )
	do i = 1, m
		x1 = i*1.0
		x2 = sqrt(x1)
		x3 = x1**(1.0/3.0)
		write( 6, 301 )  x1, x2, x3, x2**2, x3**3
301		format( 5x, 6( f9.6, 2x ) )
	end do
	return
	end




c************************************************************************
c
c	Subroutine to do the transcendental function tests
c
c************************************************************************

	subroutine  trn_test
	double precision  pi, x, s, c, s2, c2
	character junk*2

c	Error functions are *not* intrinsics--you must declare them!

	double precision derf, derfc
	
	pi = 3.141592653589793D0
	write( 6, * ) '\nPart 1: Trig Functions'
	write( 6, *) '\nGenerate a table of x, sin(x), cos(x) and the sum of their squares.\n'
	write(6, 200)
200	format( 9x, 'x', 9x, 'sin(x)', 8x, 'cos(x)', 4x, 'sin(x)^2 + cos(x)^2' )
	do i = 0, 12
		x = i * pi / 6.0
		s = dsin( x )
		c = dcos( x )
		s2 = s**2
		c2 = c**2
		write( 6, 201) i, s, c, s2 + c2
201		format( 5x, i2,'*pi/6' 3x, f11.8, 3x, f11.8, 3x, f15.10 )
	end do

	write(6,*) '\nPart 2:  Exponential functions; hit return to continue...'
	read(5,299) junk
299	format( a1 )

	write(6,*) 'Generate a table of x, log(x), and exp(log(x)).\n'
	write(6, 210)
210	format( 11x, 'x', 16x, 'log(x)', 9x, 'exp(log(x))' )
	do i = 1, 10
		x = dble(i)
		s = dlog(x)
		c = dexp(s)
		write(6, 211) x, s, c
211		format( 5x, f13.10, 5x, f13.10, 5x, f13.10 )
	end do
	
	write(6,*) '\nPart 3:  Error functions; hit return to continue...'
	read(5,299) junk

	write(6,*) 'Generate a table of x, erf(x), erfc(x), and erf(x) + erfc(x).\n'
	write(6, 220)
220	format( 8x, 'x', 11x, 'erf(x)', 10x, 'erfc(x)', 6x, 'erf(x) + erfc(x)' )
	do i = -5, 10
		x = i/10.0D0
		s = derf(x)
		c = derfc(x)
		write(6, 221) x, s, c, s+c
221		format( 5x, f5.2, 5x, 3(f13.10, 4x) )
	end do
	
	return
	end



c************************************************************************
c
c	Subroutine to do complex arithmetic tests
c
c************************************************************************

	subroutine  cm_test
	
	complex z1, z2
	
	write( 6, * ) '\nGenerate a table illustrating complex arithmetic operations.\n'
	write(6, 305)
305	format( 7x, 'z1', 13x, 'z2', 12x, 'z1**2', 10x, 'z1*z2', 11x, 'z1/z2' )
	do i = -1, 1
		do j = -1, 1
			z1 = cmplx( i*1.0, j*1.0 )
			z2 = cmplx( j+0.5, i-0.5 )
			write( 6, 301 )  z1, z2, z1**2, z1*z2, z1/z2
301			format( 2x, 4( f4.1,' + ', f4.1, 'i', 3x ), f5.2,' + ', f5.2, 'i' )
		end do
	end do
	return
	end




c************************************************************************
c
c	Subroutine to do complex algebra tests
c
c************************************************************************

	subroutine  ca_test
	
	complex z1, z2, z3, z4
	
	write( 6, * ) '\nGenerate a table of complex numbers to complex powers.\n'
	write(6, 305)
305	format( 7x, 'z1', 13x, 'z2', 14x, 'z1**z2', 8x, '(z1**z2)**(1/z2)' )
	do i = -1, 1
		do j = -1, 1
			z1 = cmplx( i*1.0, j*1.0 )
			z2 = cmplx( j+0.5, i-0.5 )
			z3 = z1**z2
			z4 = z3**(1.0/z2)
			write( 6, 301 )  z1, z2, z3, z4
301			format( 2x, 2( f4.1,' + ', f4.1, 'i', 3x ), 2(f6.2,' + ', f6.2, 'i', 3x) )
		end do
	end do
	return
	end




c************************************************************************
c
c	Subroutine to do complex function tests
c
c************************************************************************

	subroutine  cf_test
	
	complex z1, z2, z3
	
	write( 6, * ) '\nGenerate a table of z, exp(z), and log(exp(z)).\n'
	write(6, 305)
305	format( 7x, 'z', 16x, 'exp(z)', 13x, 'log(exp(z))' )
	do i = -1, 1
		do j = -1, 1
			z1 = cmplx( j+0.5, i-0.5 )
			z2 = exp(z1)
			z3 = log(z2)
			write( 6, 301 )  z1, z2, z3
301			format( 2x, f4.1,' + ', f4.1, 'i', 3x, 2(f7.3,' + ', f7.3, 'i', 3x) )
		end do
	end do
	return
	end




c************************************************************************
c
c	Subroutine to do quad integer tests
c
c************************************************************************

	subroutine  q_test
	
	integer*8 n, two, two2n, two2n1, ratio
	
	write( 6, * ) '\nGenerate a table of n, 2**n, and 2**n/2**(n-1)'
	write(6, 305)
305	format( 4x, 'n', 18x, '2**n', 13x, '2**n/2**(n-1)' )
	two = 2
	do n = 1, 62
		two2n = two**n
		two2n1 = two**(n-1)
		ratio = two2n/two2n1
		write( 6, 301 )  n, two2n, two
301		format( 2x, i3, 3x, i25, 10x, i3 )
	end do
	return
	end




